import unittest
import json
import glob
from src.workflow import Workflow

class Test_Executor_Extraction_Per_Subworkflow(unittest.TestCase):
    
        def test_wf6_extraction(self):
            w = Workflow(f"tests/ressources/workflows/wf6", display_info=False, duplicate=True)
            w.initialise()
            
            with open('tests/ressources/workflows/wf6/executors_per_subworkflows.json') as json_file:
                saved = json.load(json_file)
            saved_sets = []
            for sub in saved:
                saved_sets.append(set(saved[sub].values()))
                
            subs = w.get_subworkflows_called()
            dico= {}
            for s in subs:
                executors = s.get_all_executors_in_workflow()
                executors_vals = []
                for e in executors:
                    executors_vals.append(e.get_code(get_OG = True))
                self.assertTrue(set(executors_vals) in saved_sets)
        
        def test_wf1_extraction(self):
            w = Workflow(f"tests/ressources/workflows/wf1", display_info=False, duplicate=True)
            w.initialise()
            
            with open('tests/ressources/workflows/wf1/executors_per_subworkflows.json') as json_file:
                saved = json.load(json_file)
            saved_sets = []
            for sub in saved:
                saved_sets.append(set(saved[sub].values()))
                
            subs = w.get_subworkflows_called()
            dico= {}
            for s in subs:
                executors = s.get_all_executors_in_workflow()
                executors_vals = []
                for e in executors:
                    executors_vals.append(e.get_code(get_OG = True))
                self.assertTrue(set(executors_vals) in saved_sets)
        
        def test_wf18_extraction(self):
            w = Workflow(f"tests/ressources/workflows/wf18", display_info=False, duplicate=True)
            w.initialise()
            
            with open('tests/ressources/workflows/wf18/executors_per_subworkflows.json') as json_file:
                saved = json.load(json_file)
            saved_sets = []
            for sub in saved:
                saved_sets.append(set(saved[sub].values()))
                
            subs = w.get_subworkflows_called()
            dico= {}
            for s in subs:
                executors = s.get_all_executors_in_workflow()
                executors_vals = []
                for e in executors:
                    executors_vals.append(e.get_code(get_OG = True))
                self.assertTrue(set(executors_vals) in saved_sets)
        
        def test_wf13_extraction(self):
            w = Workflow(f"tests/ressources/workflows/wf13", display_info=False, duplicate=True)
            w.initialise()
            
            with open('tests/ressources/workflows/wf13/executors_per_subworkflows.json') as json_file:
                saved = json.load(json_file)
            saved_sets = []
            for sub in saved:
                saved_sets.append(set(saved[sub].values()))
                
            subs = w.get_subworkflows_called()
            dico= {}
            for s in subs:
                executors = s.get_all_executors_in_workflow()
                executors_vals = []
                for e in executors:
                    executors_vals.append(e.get_code(get_OG = True))
                self.assertTrue(set(executors_vals) in saved_sets)
        
        def test_wf8_extraction(self):
            w = Workflow(f"tests/ressources/workflows/wf8", display_info=False, duplicate=True)
            w.initialise()
            
            with open('tests/ressources/workflows/wf8/executors_per_subworkflows.json') as json_file:
                saved = json.load(json_file)
            saved_sets = []
            for sub in saved:
                saved_sets.append(set(saved[sub].values()))
                
            subs = w.get_subworkflows_called()
            dico= {}
            for s in subs:
                executors = s.get_all_executors_in_workflow()
                executors_vals = []
                for e in executors:
                    executors_vals.append(e.get_code(get_OG = True))
                self.assertTrue(set(executors_vals) in saved_sets)
        
        def test_wf3_extraction(self):
            w = Workflow(f"tests/ressources/workflows/wf3", display_info=False, duplicate=True)
            w.initialise()
            
            with open('tests/ressources/workflows/wf3/executors_per_subworkflows.json') as json_file:
                saved = json.load(json_file)
            saved_sets = []
            for sub in saved:
                saved_sets.append(set(saved[sub].values()))
                
            subs = w.get_subworkflows_called()
            dico= {}
            for s in subs:
                executors = s.get_all_executors_in_workflow()
                executors_vals = []
                for e in executors:
                    executors_vals.append(e.get_code(get_OG = True))
                self.assertTrue(set(executors_vals) in saved_sets)
        
        def test_wf2_extraction(self):
            w = Workflow(f"tests/ressources/workflows/wf2", display_info=False, duplicate=True)
            w.initialise()
            
            with open('tests/ressources/workflows/wf2/executors_per_subworkflows.json') as json_file:
                saved = json.load(json_file)
            saved_sets = []
            for sub in saved:
                saved_sets.append(set(saved[sub].values()))
                
            subs = w.get_subworkflows_called()
            dico= {}
            for s in subs:
                executors = s.get_all_executors_in_workflow()
                executors_vals = []
                for e in executors:
                    executors_vals.append(e.get_code(get_OG = True))
                self.assertTrue(set(executors_vals) in saved_sets)
        
        def test_wf5_extraction(self):
            w = Workflow(f"tests/ressources/workflows/wf5", display_info=False, duplicate=True)
            w.initialise()
            
            with open('tests/ressources/workflows/wf5/executors_per_subworkflows.json') as json_file:
                saved = json.load(json_file)
            saved_sets = []
            for sub in saved:
                saved_sets.append(set(saved[sub].values()))
                
            subs = w.get_subworkflows_called()
            dico= {}
            for s in subs:
                executors = s.get_all_executors_in_workflow()
                executors_vals = []
                for e in executors:
                    executors_vals.append(e.get_code(get_OG = True))
                self.assertTrue(set(executors_vals) in saved_sets)
        
        def test_wf16_extraction(self):
            w = Workflow(f"tests/ressources/workflows/wf16", display_info=False, duplicate=True)
            w.initialise()
            
            with open('tests/ressources/workflows/wf16/executors_per_subworkflows.json') as json_file:
                saved = json.load(json_file)
            saved_sets = []
            for sub in saved:
                saved_sets.append(set(saved[sub].values()))
                
            subs = w.get_subworkflows_called()
            dico= {}
            for s in subs:
                executors = s.get_all_executors_in_workflow()
                executors_vals = []
                for e in executors:
                    executors_vals.append(e.get_code(get_OG = True))
                self.assertTrue(set(executors_vals) in saved_sets)
        
        def test_wf12_extraction(self):
            w = Workflow(f"tests/ressources/workflows/wf12", display_info=False, duplicate=True)
            w.initialise()
            
            with open('tests/ressources/workflows/wf12/executors_per_subworkflows.json') as json_file:
                saved = json.load(json_file)
            saved_sets = []
            for sub in saved:
                saved_sets.append(set(saved[sub].values()))
                
            subs = w.get_subworkflows_called()
            dico= {}
            for s in subs:
                executors = s.get_all_executors_in_workflow()
                executors_vals = []
                for e in executors:
                    executors_vals.append(e.get_code(get_OG = True))
                self.assertTrue(set(executors_vals) in saved_sets)
        
        def test_wf10_extraction(self):
            w = Workflow(f"tests/ressources/workflows/wf10", display_info=False, duplicate=True)
            w.initialise()
            
            with open('tests/ressources/workflows/wf10/executors_per_subworkflows.json') as json_file:
                saved = json.load(json_file)
            saved_sets = []
            for sub in saved:
                saved_sets.append(set(saved[sub].values()))
                
            subs = w.get_subworkflows_called()
            dico= {}
            for s in subs:
                executors = s.get_all_executors_in_workflow()
                executors_vals = []
                for e in executors:
                    executors_vals.append(e.get_code(get_OG = True))
                self.assertTrue(set(executors_vals) in saved_sets)
        
        def test_wf9_extraction(self):
            w = Workflow(f"tests/ressources/workflows/wf9", display_info=False, duplicate=True)
            w.initialise()
            
            with open('tests/ressources/workflows/wf9/executors_per_subworkflows.json') as json_file:
                saved = json.load(json_file)
            saved_sets = []
            for sub in saved:
                saved_sets.append(set(saved[sub].values()))
                
            subs = w.get_subworkflows_called()
            dico= {}
            for s in subs:
                executors = s.get_all_executors_in_workflow()
                executors_vals = []
                for e in executors:
                    executors_vals.append(e.get_code(get_OG = True))
                self.assertTrue(set(executors_vals) in saved_sets)
        
        def test_wf7_extraction(self):
            w = Workflow(f"tests/ressources/workflows/wf7", display_info=False, duplicate=True)
            w.initialise()
            
            with open('tests/ressources/workflows/wf7/executors_per_subworkflows.json') as json_file:
                saved = json.load(json_file)
            saved_sets = []
            for sub in saved:
                saved_sets.append(set(saved[sub].values()))
                
            subs = w.get_subworkflows_called()
            dico= {}
            for s in subs:
                executors = s.get_all_executors_in_workflow()
                executors_vals = []
                for e in executors:
                    executors_vals.append(e.get_code(get_OG = True))
                self.assertTrue(set(executors_vals) in saved_sets)
        
        def test_wf4_extraction(self):
            w = Workflow(f"tests/ressources/workflows/wf4", display_info=False, duplicate=True)
            w.initialise()
            
            with open('tests/ressources/workflows/wf4/executors_per_subworkflows.json') as json_file:
                saved = json.load(json_file)
            saved_sets = []
            for sub in saved:
                saved_sets.append(set(saved[sub].values()))
                
            subs = w.get_subworkflows_called()
            dico= {}
            for s in subs:
                executors = s.get_all_executors_in_workflow()
                executors_vals = []
                for e in executors:
                    executors_vals.append(e.get_code(get_OG = True))
                self.assertTrue(set(executors_vals) in saved_sets)
        
        def test_wf15_extraction(self):
            w = Workflow(f"tests/ressources/workflows/wf15", display_info=False, duplicate=True)
            w.initialise()
            
            with open('tests/ressources/workflows/wf15/executors_per_subworkflows.json') as json_file:
                saved = json.load(json_file)
            saved_sets = []
            for sub in saved:
                saved_sets.append(set(saved[sub].values()))
                
            subs = w.get_subworkflows_called()
            dico= {}
            for s in subs:
                executors = s.get_all_executors_in_workflow()
                executors_vals = []
                for e in executors:
                    executors_vals.append(e.get_code(get_OG = True))
                self.assertTrue(set(executors_vals) in saved_sets)
        
        def test_wf17_extraction(self):
            w = Workflow(f"tests/ressources/workflows/wf17", display_info=False, duplicate=True)
            w.initialise()
            
            with open('tests/ressources/workflows/wf17/executors_per_subworkflows.json') as json_file:
                saved = json.load(json_file)
            saved_sets = []
            for sub in saved:
                saved_sets.append(set(saved[sub].values()))
                
            subs = w.get_subworkflows_called()
            dico= {}
            for s in subs:
                executors = s.get_all_executors_in_workflow()
                executors_vals = []
                for e in executors:
                    executors_vals.append(e.get_code(get_OG = True))
                self.assertTrue(set(executors_vals) in saved_sets)
        
        def test_wf14_extraction(self):
            w = Workflow(f"tests/ressources/workflows/wf14", display_info=False, duplicate=True)
            w.initialise()
            
            with open('tests/ressources/workflows/wf14/executors_per_subworkflows.json') as json_file:
                saved = json.load(json_file)
            saved_sets = []
            for sub in saved:
                saved_sets.append(set(saved[sub].values()))
                
            subs = w.get_subworkflows_called()
            dico= {}
            for s in subs:
                executors = s.get_all_executors_in_workflow()
                executors_vals = []
                for e in executors:
                    executors_vals.append(e.get_code(get_OG = True))
                self.assertTrue(set(executors_vals) in saved_sets)
        
        def test_wf11_extraction(self):
            w = Workflow(f"tests/ressources/workflows/wf11", display_info=False, duplicate=True)
            w.initialise()
            
            with open('tests/ressources/workflows/wf11/executors_per_subworkflows.json') as json_file:
                saved = json.load(json_file)
            saved_sets = []
            for sub in saved:
                saved_sets.append(set(saved[sub].values()))
                
            subs = w.get_subworkflows_called()
            dico= {}
            for s in subs:
                executors = s.get_all_executors_in_workflow()
                executors_vals = []
                for e in executors:
                    executors_vals.append(e.get_code(get_OG = True))
                self.assertTrue(set(executors_vals) in saved_sets)
        